program KolFtp;
{************************************************************
 1.019 BETA Release 4, Public Beta 1.
 ************************************************************
 This work is partally based on an example from
 Marcel van Brakel, witten for JEDI
 Although some of the code may look the same, It's a complete
 rewrite with added/different features.
 This program does not use any of the JEDI library
 translations, but Borlands own WININI.PAS
 ************************************************************
 Except where this may be applicable to snippets from Marcel
 (GNU licence) This code is public domain freeware.
 (not copyrighted) Use at your own risk,
 The Author is not liable for any damage in any way that the
 use or compilation of this program or its code may cause.
 ************************************************************

 KOLFTP is a simple and small FTP program with the following
 Features:
 - Uploading by File drop from other applications
   (not the other way yet.
 - Uploading (multiple) files
 - Downloading (multi-) selectable files
 - Deleting (multiple)local remote files
 - Renaming local and remote files
 - Simple FTP Sites manager
 - Connection log.
 All connections are synchronous, so you have to wait until an operation
 is Finished!

Known issues:
1) Sorting on filesize not implemented correctly
2) Drag from FTPKOL to explorer not implemented yet.
3  Internal drag (To-from different panes) not implemented yet
4) There are various optimizations to be made.
5) Availability and unavailability of options partially
   not indicated correctly everywhere and anywhere.
6) Up/Download and Delete operations do not work on directories
7) Should be partially asynchronous

Pleas report any bugs, fixes, other than the above to
thaddy@thaddy.com descibing:
- Release version(Above, here 1.019)
- Issue Topic
- Issue Description
- Replication instructions
- Possible solution/ Code fix
- Your Name and emailaddress

}
uses
  Windows,
  Messages,
  Kol,
  Wininet,
  commctrl,{The real one, not the KOL include in this case!}
  ShellApi;

{$R *.RES}

Type
  pEventCentral=^TeventCentral;
  TeventCentral=object(Tobj)
    procedure DoCmdOk(Sender:pObj);
    procedure DoCmdCancel(sender:pObj);
    procedure DoCmdAdd(Sender:pObj);
    procedure DoCmdDelete(sender:pObj);
    procedure OnListKeyUp(sender:pControl;var Key:longint;shift:dword);
    function  DoOnRemoteListViewMessage(var Msg:Tmsg;var Rslt:Integer):Boolean;
    function  DoOnLocalListViewMessage(var Msg:Tmsg;var Rslt:Integer):Boolean;
{    function  DoOnGlobalMessage(var Msg:Tmsg;var Rslt:Integer):Boolean;}
    procedure SitesListBoxClick(Sender: pObj);
    procedure DoMenu(Sender:pMenu;Item:integer);
    procedure DriveComboboxChange(Sender:pObj);
    procedure DoToolbarClick(sender:pObj);
    procedure DoPopUp(sender:pMenu;Item:integer);
  end;

  function NewEvents:pEventCentral;
  begin
    New(result,Create);
  end;



  procedure DownLoad;forward;
  procedure UpLoad;forward;
  procedure LoadSites;forward;
  procedure SaveSites;forward;
  procedure ClearRemoteImageList;forward;
  procedure ClearLocalImagelist;Forward;
  procedure RemoteUpdateListing;forward;
  procedure LocalUpdateListing;forward;
  procedure InetCallback(HInternet: HINTERNET; dwContext, dwInternetStatus: DWORD;
   lpStatusInfo: Pointer; dwStatusInfoLen: DWORD); stdcall;forward;
  procedure Disconnect;forward;
  procedure Connect;forward;
  function SortFunc(Item1,Item2,Column:integer):integer stdCall;forward;
  function GetFileTypeIcon(const Name: string; UseAttr: Boolean): HICON;forward;
  function GetFileTypeDescription(const Name: string; UseAttr: Boolean): string;forward;
  function FileSizeToString(const Size: Int64): string;forward;

const

  faDirectory = $00000010;

type

  TFileName = type string;
  TtoolbarButton=(tbUpLevel,tbGoto,tbRefresh,tbConnect,tbDisconnect,
                  tbCancel,tbQuickConnect,tbDownloadTo,tbDownLoad,tbUpload,
                  tbdelete,tbproperties,tbLargeIcons,tbsmallicons,tblist,
                  tbdetails,tbAscii,tbBinary,tbLog);
  TTbButtons=set of TToolbarButton;

  TmenuItem=(mnFile,mnShowSites,mnConnect,mnDisconnect,mnExit);
  TmenuItems=set of TmenuItem;

var
 DriveDlg:pOpenDirDialog;
 Applet,
 MainForm,
 tbPanel,
 Toolbar,
 Panel,
 Panel1,
 Label1,
 Label2,
 Label3,
 Label4,
 Label5,
 CmdAdd,
 CmdDelete,
 CmdOk,
 CmdCancel,
 DirComboBox,
 SitesForm,
 DirButton,
 Status,
 LocalListView,
 RemoteListView,
 SiteName,
 HostAddressName,
 EdiUsername,
 EdiPassword,
 EdiPort,
 cbAnonymous,
 Splitter,
 SitesListBox:
              pControl;

 LocalViewImages,
 RemoteViewImages:pImagelist;
 tbimages:pBitmap;

 Fsites:pStrList;
 FLocalPath: string;
 FRemotePath: string;
 FtpHandle: HInternet;
 InetHandle: HInternet;
 Mainmenu,
 LPopup,
 RPopup:pMenu;
 Events:pEventCentral;
 Drives:DWORD;
 i:Integer;
 Shift:dword;
 TotalBytesSend,
 TotalBytesReceived:int64;

 RemoteSort:Boolean=false;//Global flag to optimize sortcode

 DragList:plist;


procedure TeventCentral.DoToolBarClick(sender:pObj);
var Key:integer;
begin
Key:=VK_delete;
with Toolbar^ do
  Case TToolbarbutton(CurItem-100) of
  tbUplevel          :;
  tbGoto             :;
  tbrefresh          :begin localUpdateListing;remoteupdatelisting;end;
  tbConnect          :connect;
  tbDisconnect       :disconnect;
  tbCancel           :;
  tbQuickConnect     :;
  tbDownLoadto       :;
  tbDownload         :DownLoad;
  tbUpload           :UpLoad;
  tbDelete           :Events.OnListKeyUp(RemoteListView,Key,0);
  tbproperties       :;
  tbLargeIcons       :;
  tbSmallIcons       :;
  tbList             :;
  tbDetails          :;
  tbAscii            :;
  tbBinary           :;// Toolbar.TBButtonPressed[116]:=not  Toolbar.TBButtonPressed[116];
  tbLog              :begin
                       if  status.height=100 then
                        begin
                          status.Height:=1;
                          Toolbar.TBButtonPressed[Ord(tbLog)+100]:=false;
                        end
                        else
                        begin
                          status.Height:=100;
                          Toolbar.TBButtonPressed[Ord(tbLog)+100]:=true;
                        end;
                        Status.ResizeParent;
                       end;
  end;
end;

function ShowError(ErrorCode: Integer): string;
var
  Buffer: array[0..255] of Char;
begin
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or
    FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, ErrorCode, 0, Buffer,
    SizeOf(Buffer), nil);
  MsgOk(Buffer);
end;


procedure CollectSelectedItems(aListView:pControl;var aList:PstrList);
var i:integer;
begin
 aList.Clear;
 with aListView^ do
   for I := 0 to lvCount - 1 do
     if (Perform(LVM_GETITEMSTATE,i,LVIS_SELECTED)=LVIS_SELECTED) and
       (LVItemImageIndex[I] <> 0) then
        aList.Add(LVItems[I,0]);
end;

function  TeventCentral.DoOnRemoteListViewMessage(var Msg:Tmsg;var Rslt:Integer):Boolean;
var
  p:integer;
  info:TLVHITTESTINFO;
  Point:tpoint;
  NumFiles:integer;
  Buffer:Array[0..1024]  of Char;
begin
  result:=false;
  GetCursorpos(point);
  case msg.message of
    WM_DROPFILES:
    begin
      {We are handling this message}
      Result:=true;
      {How many files are being dropped}
      {TWMDropfiles.Drop actually maps to TMsg.Wparam}
      NumFiles := DragQueryFile(Msg.Wparam,DWORD(-1),nil,0);
      {Accept and upload the dropped files}
      for p := 0 to (NumFiles - 1) do
      begin
        DragQueryFile(Msg.Wparam,p,@buffer,sizeof(buffer));
      if not FtpPutFile(FtpHandle,Buffer, PChar(FRemotePath + ExtractFilename(Buffer)),
        FTP_TRANSFER_TYPE_BINARY, 255) then ShowError(getlasterror);
      end;
      RemoteUpdateListing;
    end;
    WM_RBUTTONDOWN:RPopup.Popup(point.x,point.y);
    WM_LBUTTONDBLCLK:
      with RemoteListView^ do
      begin
        info.pt:=screen2client(point);
        p:=perform(LVM_HITTEST,0,integer(@info));
        if LvItemImageIndex[p]= 0 then
          if LvItems[p,0]<> '..' then
            FRemotePath := FRemotePath + RemoteListView.LvItems[p,0]+ '/'
          else
            begin
              DeleteTail(FRemotePath, 1);
              P := DelimeterLast(Fremotepath,'/');
              DeleteTail(FRemotePath, Length(FRemotePath) - P+1);
            end;
      RemoteUpdateListing;
      end;

    WM_NOTIFY:
        if pNMHDR(msg.lparam).Code=HDN_ITEMCLICK then
         with RemoteListView^ do
          begin
            RemoteSort:=True;
            result:=boolean(Perform(LVM_SORTITEMS,pHDNOTIFY(Msg.Lparam).ITem,integer(@Sortfunc)))
          end
          else
        Result:=False;
  end;
end;

function  TeventCentral.DoOnLocalListViewMessage(var Msg:Tmsg;var Rslt:Integer):Boolean;
var
  p:integer;
  info:TLVHITTESTINFO;
  Point:Tpoint;
begin
  Result:=False;
  getcursorpos(point);
  case msg.message of
  WM_RBUTTONDOWN:;//LPopup.Popup(point.x,point.y);
  {Local Dragging, Not Finished!
  WM_LBUTTONUP:
   imagelist_enddrag;
  WM_MOUSEMOVE:
    if ( msg.wParam and MK_LBUTTON )>0 then
      begin
      getcursorpos(point);
      point:=mainform.screen2client(point);
      imagelist_dragmove(point.x,point.y);
      result:=false;
    end ;//else result:=false;
  }
  WM_LBUTTONDBLCLK:
    with LocalListView^ do
      begin
        info.pt:=screen2client(point);
        p:=Perform(LVM_HITTEST,0,integer(@info));
        if LvItemImageIndex[p]=0 then
          if LvItems[p,0]<> '..' then
            FlocalPath := FLocalPath + LocalListView.LvItems[p,0]+ '\'
          else
          begin
            DeleteTail(FLocalPath, 1);
            P := DelimeterLast(FlocalPath,'\');
            DeleteTail(FLocalPath, Length(FLocalPath) -p+1);
          end;
      LocalUpdateListing;
      end;
  LVM_EDITLABEL:MsgOk('Edit Send');
    WM_NOTIFY:
      begin
      Status.Add(int2str(pNmHdr(msg.lparam).code)+#13#10);
        case  pNMHDR(msg.lparam).Code of
        HDN_ITEMCLICK:
         with localListView^ do
          begin
            RemoteSort:=False;
            result:=boolean(Perform(LVM_SORTITEMS,pHDNOTIFY(Msg.Lparam).ITem,integer(@Sortfunc)))//integer(@Sortfunc));
          end;
        LVN_KEYDOWN:
         begin
           MsgOk('Drag!');
           result:=true;
         end;
        LVN_BEGINLABELEDIT:
         begin
            MsgOk('Begin Edit');
            Result:=true;
         end;
          else
          begin
         Result:=False;
         end;
      end;
        end;
  end;
end;




function SortFunc(Item1,Item2,Column:integer):integer stdCall;
var
  Info:TLVFindInfo;
  ListView:pControl;
begin
  if RemoteSort=true then
    ListView:=RemoteListView
  else
    ListView:=LocalListView;
  info.lParam:=Item1;
  info.flags:=LVFI_PARAM;
  Item1:=ListView.Perform(LVM_FINDITEM,-1,integer(@Info));
  info.lParam:=Item2;
  info.flags:=LVFI_PARAM;
  Item2:=ListView.Perform(LVM_FINDITEM,-1,integer(@Info));
  with ListView^ do
    result:=AnsiCompareStr(lVitems[Item1,Column],lvitems[Item2,Column]);
end;


procedure domakedir;
var
  Name: string;
  var
    i:integer;
    F:Boolean;
begin
    if ftphandle=nil then begin MsgOk('Not Connected');exit;end;
    Name:='New Folder';
    i:=0;
    repeat
    {Create a unique name :-] }
     F:= FtpCreateDirectory(FtpHandle, PChar(FRemotePath + Name));
      inc(i);
      Name:=Name+Int2str(i);
    until (F=true) or (i=100);{100 for arbitrary bail out of loop!}
    RemoteUpdateListing;
end;

procedure Upload;
var
  FileList: pStrList;
  I: Integer;
begin
  FileList := NewStrList;
  with LocalListView^ do
  try
    Toolbar.TbButtonpressed[ord(tbUpLoad)+100]:=true;
    CollectSelectedItems(LocalListView,FileList);
    for I := 0 to FileList.Count - 1 do
    begin
      if not FtpPutFile(FtpHandle, PChar(FlocalPath + FileList.Items[I]), PChar(FRemotePath + FileList.Items[I]),
        FTP_TRANSFER_TYPE_BINARY, 255) then ShowError(getlasterror);
    end;
  finally
    FileList.free;
    RemoteUpdateListing;
    Toolbar.TbButtonpressed[ord(tbUpLoad)+100]:=False;
  end;
end;

procedure DrUpload;
var
  FileList: pStrList;
  I: Integer;
begin
  FileList := NewStrList;
  with LocalListView^ do
  try
    Toolbar.TbButtonpressed[ord(tbUpLoad)+100]:=true;
    CollectSelectedItems(LocalListView,FileList);
    for I := 0 to FileList.Count - 1 do
    begin
      if not FtpPutFile(FtpHandle, PChar(FlocalPath + FileList.Items[I]), PChar(FRemotePath + FileList.Items[I]),
        FTP_TRANSFER_TYPE_BINARY, 255) then ShowError(getlasterror);
    end;
  finally
    FileList.free;
    RemoteUpdateListing;
    Toolbar.TbButtonpressed[ord(tbUpLoad)+100]:=False;
  end;
end;

procedure Download;
var
  FileList: pStrList;
  I: Integer;
begin
  Toolbar.TBButtonPressed[Ord(tbDownLoad)+100]:=true;
  FileList := NewStrList;
  with RemoteListView^ do
  try
    CollectSelectedItems(RemoteListView,FileList);
    for I := 0 to FileList.Count - 1 do
      if not FtpGetFile(FtpHandle, PChar(FRemotePath + FileList.Items[I]), PChar(FLocalPath + FileList.Items[I]),
        True, FILE_ATTRIBUTE_NORMAL, FTP_TRANSFER_TYPE_BINARY or INTERNET_FLAG_RELOAD, 255)
      then ShowError(getLastError);
  finally
    FileList.free;
    LocalUpdateListing;
  end;
  Toolbar.TBButtonPressed[Ord(tbDownLoad)+100]:=False;
end;





procedure ShowSiteManager;
begin;
  SitesForm.ShowModal;
end;

procedure connect;
var
  Server, Usr, Pw: string;
  Port: Integer;
  i:integer;
begin
  if SitesForm.ModalResult = ID_OK then
  begin
    Disconnect;
    InetHandle := InternetOpen(PChar('KOLFTP'), 0, nil, nil, 0);
    InternetSetStatusCallback(InetHandle, @InetCallback);
    Server := HostAddressName.Text;
    Usr    := EdiUserName.Text;
    Pw     := EdiPassword.Text;
    Port   := Str2Int(EdiPort.Text);
    if CbAnonymous.Checked then
      FtpHandle := InternetConnect(InetHandle, PChar(Server), Port, nil,
        nil, INTERNET_SERVICE_FTP, 0, 255)
    else
      FtpHandle := InternetConnect(InetHandle, PChar(Server), Port, PChar(Usr),
        PChar(Pw), INTERNET_SERVICE_FTP, 0, 255);
    if not Assigned(FtpHandle) then
    begin
      InternetCloseHandle(InetHandle);
      MsgOk('Connection Failed');
    end
    else begin
      MainForm.StatusText[0]:='Connected';
      RemoteUpdateListing;
      Toolbar.TbButtonEnabled[Ord(tbConnect)+100]:=False;
      Toolbar.TbButtonEnabled[Ord(tbDisConnect)+100]:=true;
      Toolbar.TbButtonEnAbled[Ord(tbDownload)+100]:=true;
      Toolbar.tbButtonEnabled[Ord(TbUpload)+100]:=true;
      for i:= 0 to RPopup.count-1 do RPopup.ItemEnabled[i]:=true;
      MainMenu.ItemEnabled[Ord(mnConnect)]:=False;
      MainMenu.ItemEnabled[Ord(mnDisconnect)]:=true;

    end;
  end;
end;

procedure disconnect;
begin
 InternetCloseHandle(FtpHandle);
 InternetCloseHandle(InetHandle);
 FtpHandle:=nil; //so I can check for connection more easily
 inetHandle:=nil;
 Mainform.StatusText[0]:='Disconnected';
 Toolbar.TbButtonEnabled[Ord(tbConnect)+100]:=True;
 Toolbar.TbButtonEnabled[Ord(tbDisConnect)+100]:=False;
 Toolbar.TbButtonEnAbled[Ord(tbDownload)+100]:=False;
 Toolbar.tbButtonEnabled[Ord(TbUpload)+100]:=False;
end;

procedure TeventCentral.DoMenu(Sender:pMenu;Item:integer);
begin
  Case TmenuItem(Item) of
    mnShowSites:ShowSitemanager;
    mnConnect:Connect;
    mnDisconnect:DisConnect;
    mnExit:begin
        disconnect;
        SendMessage(Applet.handle,WM_CLOSE,0,0);
      end;
    else ;
  end;
end;

// =============================================================================
// Internet Callback function
// =============================================================================

// Very simple implementation of callback. Simply display the status. Some of
// the statuscodes provide additional data in the lpStatusInfo pointer but only
// a few of them have been implemented.

procedure InetCallback(HInternet: HINTERNET; dwContext, dwInternetStatus: DWORD;
  lpStatusInfo: Pointer; dwStatusInfoLen: DWORD); stdcall;
procedure LogIt(Text:string;Panel:integer=0);
begin
  Status.Add(Text+#13#10);
  Mainform.StatusText[Panel]:=Pchar(Text);
end;

begin
  case dwInternetStatus of
    INTERNET_STATUS_RESOLVING_NAME:
      LogIt('Resolving Name');
    INTERNET_STATUS_NAME_RESOLVED:
      begin
       Logit('Name Resolved');
       Logit(PChar(lpStatusInfo),1);
      end;
    INTERNET_STATUS_CONNECTING_TO_SERVER:
        LogIt('Connected');
    INTERNET_STATUS_CONNECTED_TO_SERVER:
      LogIt('Connected to Server');
    INTERNET_STATUS_SENDING_REQUEST:
        LogIt('Sending Request');
    INTERNET_STATUS_REQUEST_SENT:
      begin
       Logit('Request Send');
       TotalBytesSend:=TotalBytesSend+DWORD(lpStatusInfo^);
       LogIt(Int2Str(TotalBytesSend) + ' bytes send',2);
      end;
    INTERNET_STATUS_RECEIVING_RESPONSE:
      Logit('Receiving Response');
    INTERNET_STATUS_RESPONSE_RECEIVED:
      begin
      Logit('Response Received');
      TotalBytesReceived:=TotalBytesReceived+DWORD(lpStatusInfo^);
      Logit(Int2Str(TotalBytesReceived) + ' bytes received',3);
      end;
    INTERNET_STATUS_CTL_RESPONSE_RECEIVED:
      Logit('Ctl Response Received');
    INTERNET_STATUS_PREFETCH:
      Logit('Prefetch');
    INTERNET_STATUS_CLOSING_CONNECTION:
        LogIt('Closing Connection');
    INTERNET_STATUS_CONNECTION_CLOSED:
      LogIt('Connection Closed');
    INTERNET_STATUS_HANDLE_CREATED:
      LogIt('Handle Created');
    INTERNET_STATUS_HANDLE_CLOSING:
      LogIt('Handle Closing');
    INTERNET_STATUS_REQUEST_COMPLETE:
      Logit('Request Complete');
    INTERNET_STATUS_REDIRECT:
      LogIt('Redirect');
    INTERNET_STATUS_INTERMEDIATE_RESPONSE:
      LogIt('Intermediate Response');
    INTERNET_STATUS_STATE_CHANGE:
      LogIt('Changing');
  else
    LogIt('Status Unknown');
  end;
end;

procedure RemoteUpdateListing;
var
  F: TWin32FindData;
  Enum: HInternet;
  R: Bool;
  FileName: string;
  FileSize: Int64;
  Magic:integer;
begin
  Enum := nil;
  Magic:=0;
  with remotelistview^ do
  try
    ClearRemoteImageList;
    Clear;
    Update;
    Applet.processpendingmessages;
    Perform(WM_SETREDRAW,0,0);
    Enum := FtpFindFirstFile(FtpHandle, PChar(FRemotePath + '*.*'), F, 0, 255);
    inc(Magic);
    R := Enum <> nil;
    while R do
    begin
      FileName := F.cFileName;
      if Filename<>'.' then
      begin
        LvAdd(Filename,0,[],0,0,Magic);
        FileSize := (F.nFileSizeHigh shl 32) or (F.nFileSizeLow);
        if F.dwFileAttributes and faDirectory = faDirectory then
        begin
          LvItems[lvcount-1,1]:='';
          LvItems[LvCount-1,2]:='File Folder';
          LvItemImageIndex[lvcount-1] := 0;
        end
        else
        begin
          LvItems[lvcount-1,1]:=FileSizeToString(FileSize);
          LvItems[LvCount-1,2]:=GetFileTypeDescription(FRemotePath + FileName, True);
          LvItemImageIndex[lvcount-1]:=
             RemoteViewImages.AddIcon(GetFileTypeIcon(FRemotePath + FileName, True));
        end;
       end;
       inc(Magic);
      R := InternetFindNextFile(Enum, @F);
    end;
  finally
    InternetCloseHandle(Enum);
    RemoteSort:=True;
    {Sorts on name only}
    Perform(LVM_SORTITEMS,0 ,0);
    {Sorts on Size forcing directories first 0 size 0!}
    Perform(LVM_SORTITEMS,1,integer(@Sortfunc));
    perform(WM_SETREDRAW,1,0);
    Mainform.Update;
  end;
end;

procedure LocalUpdateListing;
var
  F: TWin32FindData;
  Enum: Hwnd;
  R: Bool;
  FileName: string;
  FileSize: Int64;
  Magic:integer;
begin
  Pointer(Enum) := nil;
  with localListView^ do
  try
    ClearLocalImageList;
    Clear;
    Update;
    Applet.processpendingmessages;
    perform(WM_SETREDRAW,0,0);
    Enum := FindFirstFile(PChar(FLocalPath + '*.*'), F);
    R := Pointer(Enum) <> nil;
    Magic:=0;
    while R do
    begin
      FileName := F.cFileName;
      if filename <>'.' then
      begin
        LvAdd(Filename,0,[],0,0,Magic);
        LvItems[LvCount-1,0]:=Filename;
        FileSize := (F.nFileSizeHigh shl 32) or (F.nFileSizeLow);
        if F.dwFileAttributes and faDirectory = faDirectory then
        begin
          LvItems[lvcount-1,1]:='';
          LvItems[LvCount-1,2]:='File Folder';
          LvItemImageIndex[lvcount-1] := 0;
        end
        else
        begin
          LvItems[lvcount-1,1]:=FileSizeToString(FileSize);
          LvItems[LvCount-1,2]:=GetFileTypeDescription(FLocalPath + FileName, True);
          LvItemImageIndex[lvcount-1]:=
             LocalViewImages.AddIcon(GetFileTypeIcon(FLocalPath + FileName, True));
        end;
       end;
       inc(Magic);
      R := FindNextFile(Enum, F);
    end;
  finally
    Findclose(Enum);
    {Sorts on name only}
    RemoteSort:=False;
    Perform(LVM_SORTITEMS,0 ,0);
    {Sorts on Size forcing directories first 0 size 0!}
    Perform(LVM_SORTITEMS,1,integer(@Sortfunc));
    perform(WM_SETREDRAW,1,0);
  end;
    Mainform.Update;
end;

procedure ClearLocalImageList;
begin
  LocalViewImages.Clear;
  {Is resourced in kol Version, not need to check}
  LocalViewImages.LoadBitmap('FOLDERCLOSED',clFuchsia);
end;

procedure ClearRemoteImageList;
begin
  RemoteViewImages.Clear;
  {Is resourced in kol Version, not need to check}
  RemoteViewImages.LoadBitmap('FOLDERCLOSED',clFuchsia);
end;

function FileSizeToString(const Size: Int64): string;
var
  S: Integer;
begin
  if Size < 1024 then
    Result := Int2Str(Size) + ' Bytes';
  begin
    S := Size div 1024;
    if S = 0 then S := 1;
    if S < 1024 then
      Result := Int2Str(S) + ' KB'
    else begin
      S := S div 1024;
      if S = 0 then S := 1;
      Result := Int2Str(S) + ' MB';
    end;
  end;
end;

function GetFileTypeDescription(const Name: string; UseAttr: Boolean): string;
var
  Info: TSHFileInfo;
  Flags: Cardinal;
begin
  FillChar(Info, SizeOf(Info), 0);
  Flags := SHGFI_TYPENAME;
  if UseAttr then Flags := Flags or SHGFI_USEFILEATTRIBUTES;
  SHGetFileInfo(PChar(Name), 0, Info, SizeOf(Info), Flags);
  Result := Info.szTypeName;
end;

function GetFileTypeIcon(const Name: string; UseAttr: Boolean): HICON;
var
  Info: TSHFileInfo;
  Flags: Cardinal;
begin
  FillChar(Info, SizeOf(Info), 0);
  Flags := SHGFI_ICON or SHGFI_SMALLICON;
  if UseAttr then Flags := Flags or SHGFI_USEFILEATTRIBUTES;
  SHGetFileInfo(PChar(Name), 0, Info, SizeOf(Info), Flags);
  Result := Info.hIcon;
end;

function UIToString: string;
var
  S: string;
begin
  S := SiteName.Text + ';';
  S := S + HostAddressName.Text + ';';
  S := S + EdiUserName.Text + ';';
  S := S + EdiPassword.Text + ';';
  if CbAnonymous.Checked then S := S + '1;' else S := S + '0;';
  if EdiPort.Text <> '' then S := S + EdiPort.Text else S := S + '21';
  Result := S;
end;

procedure LoadSites;
var
  I:Integer;
  S: string;
begin
  FSites.Clear;
  SitesListBox.Clear;
  FSites.LoadFromFile('Sites.sts');
  for I := 0 to FSites.Count - 1 do
  begin
    S := FSites.Items[I];
    SitesListBox.Add(Parse(s,';'));
  end;
end;

procedure SaveSites;
begin
  FSites.SaveToFile('Sites.sts');
  LoadSites;
end;

procedure TeventCentral.SitesListBoxClick(Sender: pObj);
var
  S: string;
begin
  S := FSites.Items[SitesListBox.CurIndex];
  SiteName.Text := Parse(s,';');
  HostAddressName.Text := Parse(s,';');
  EdiUserName.Text := Parse(s,';');
  EdiPassword.Text := Parse(s,';');
  CbAnonymous.Checked := Parse(s,';')='1';
  EdiPort.Text := S;
end;

procedure TeventCentral.DoCmdDelete(sender:pObj);
begin
  If SitesListBox.CurItem<>-1 then
  begin
   Fsites.delete(SitesListBox.CurItem);
   SaveSites;
   LoadSites;
   end;
end;

procedure TeventCentral.DoCmdAdd(Sender:pobj);
var
  S: string;
begin
  S := UIToString;
  FSites.Add(S);
  SitesListBox.Add(SiteName.Text);
  SaveSites;
end;



procedure TeventCentral.DoCmdCancel(sender:pObj);
begin
  Sitesform.ModalResult:=ID_CANCEL;
  SitesForm.Hide;
end;

procedure TeventCentral.DoCmdOk(Sender:pObj);
begin
  if SitesListBox.CurIndex >= 0 then FSites.Items[SitesListBox.CurIndex] := UIToString;
  SaveSites;
  CmdOk.ModalResult := ID_OK;
  SitesForm.ModalResult:=ID_OK;
  SitesForm.Hide;
end;

procedure TeventCentral.DriveComboboxChange(Sender:pObj);

begin
  FLocalPath := DirComboBox.Items[DirCombobox.CurIndex] + ':\';
  LocalUpdateListing;
end;

procedure TeventCentral.OnListKeyUp(sender: pControl;
  var Key: Integer; shift: dword);
var FileList:pStrList;
i:integer;
begin
  FileList:=NewStrList;
  if (Key=VK_DELETE) then
    if sender=LocalListView then
      begin
       msgOk('Delete pressed local')
      end
    else if sender= remotelistview then
      begin
        with remoteListView^ do
        try
          CollectSelectedItems(RemoteListView,FileList);
          if MessageBox(Mainform.handle,'Are you shure you want to delete these files?', 'Delete Files',MB_YESNO)=ID_YES then
          for I := 0 to FileList.Count - 1 do
            if not FtpDeleteFile(ftphandle, PChar(FRemotePath + FileList.Items[I]))
              then ShowError(getlasterror);
        finally
          FileList.free;
          RemoteUpdateListing;
        end;
  end;
end;

Type
TPopupItem=(puDownLoad,puDelete,puRename,puNewFolder);
TpopupItems=set of TpopupItem;

procedure TeventCentral.DoPopUp(sender: pMenu; Item: integer);
var Key:Integer;
begin
Key:=VK_DELETE;
if sender=Rpopup then
  case Item of
  Ord(puDownload):Download;
  Ord(puDelete):Events.OnListKeyUp(RemoteListView,Key,0);
  Ord(puRename):;
  Ord(puNewFolder):DoMakedir;
  end
else if sender=Lpopup then
  case Item of
  Ord(puDownload):Upload;
  Ord(puDelete):Events.OnListKeyUp(RemoteListView,Key,0);
  Ord(puRename):;//RenameFile(;
  Ord(puNewFolder):DoMakedir;
  end;

end;
{
function TeventCentral.DoOnGlobalMessage(var Msg: Tmsg;
  var Rslt: Integer): Boolean;
begin
  result:=false;
  if msg.message=WM_NOTIFY then
  case pNmHdr(msg.lparam).code of
    LVN_BEGINLABELEDIT:
      begin
      MsgOk('Trapped begin Edit');
      result:=true;
      end;
    {Not Finished;
    LVN_BEGINDRAG:
      begin
      getcursorpos(point);
      point:=LocalListView.Screen2Client(point);
      Draglist.clear;
      with locallistview^ do
        for index:= 0 to LvCount-1 do
          if (Perform(LVM_GETITEMSTATE,index,LVIS_SELECTED)=LVIS_SELECTED) then
       begin
       Draglist.Add(Pointer(listview_createdragimage(LocalListview.handle,Index,point)));
       break;
       end;
      imagelist_begindrag(hwnd(Draglist.Items[0]),0,0,0);
      imagelist_dragenter(LocalListView.Handle,point.x,point.y);
      result:=true;
      end;
  else result:=False;
  end;
end;
}
begin
  FLocalPath := 'c:\';
  FRemotePath := '/';
  FtpHandle := nil;
  InetHandle := nil;
  Events:=NewEvents;
  Applet:=NewApplet('KolFtp');
  Applet.Font.FontHeight:=11;

  Mainform:=NewForm(Applet,'Kol Ftp').SetSize(800,500).CenterOnParent;
  MainForm.Statustext[4]:='';
{  Mainform.OnMessage:=Events.DoOnGlobalMessage;}
  TbPanel:=NewPanel(MainForm,esNone).SetAlign(caTop);

  TbImages:=NewBitMap(304,16);
  TbImages.LoadFromResourceName(hinstance,'TOOLBARBMP');
  TbImages.Dormant;

  Toolbar:=NewToolbar(TbPanel,caTop,[tboFlat,tboTextRight]
    ,tbImages.Handle
    ,[' ',' ',' ','-!','-!',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','-!','']
    ,[]).ResizeParent;
  Toolbar.Transparent:=True;
  Toolbar.TBSetTooltips(100,['Up one Level','Go to','Refresh','Connect','Disconnect',
                             'Cancel','Quick Connect','Download to','DownLoad','Upload'
                             ,'Delete','Properties','','','','','Ascii mode', 'Binary Mode','Show Log']);

  with Toolbar^ do
  begin
    for i:=111 to 117 do
      TBButtonVisible[i]:=false;
    tbButtonVisible[Ord(tbUpLevel)+100]:=False;
    tbButtonVisible[Ord(tbGoto)+100]:=False;
    tbButtonVisible[Ord(tbCancel)+100]:=False;
    tbButtonVisible[Ord(tbQuickConnect)+100]:=False;
    tbButtonVisible[Ord(tbDownLoadto)+100]:=False;
    TbButtonEnabled[Ord(tbConnect)+100]:=true;
    TbButtonEnabled[Ord(tbDisConnect)+100]:=False;
    TbButtonEnabled[Ord(tbDownLoad)+100]:=False;
    TbButtonEnabled[Ord(tbUpLoad)+100]:=False;
    TbButtonVisible[Ord(tbDelete)+100]:=False;
    OnTBClick:=Events.DoToolbarClick;
  end;
  Panel:=NewPanel(MainForm,esNone).SetAlign(caTop);
  Panel.Height:=20;

  DirComboBox:=NewComboBox(Panel,[coReadOnly,coSort]).SetSize(50,20);
  Drives:=GetLogicalDrives;
  Shift:=1;
  for i:=1 to 32 do
    begin
    if (Drives AND SHIFT)=SHIFT then DirCombobox.Add(Char(64+i));
    shift:=(shift shl 1);
    end;
  DirCombobox.CurIndex:=1;
  DirComboBox.OnChange:=Events.DriveComboBoxChange;


  LocalViewImages:=NewImageList(Mainform);
  LocalListView:=NewListView(MainForm,lvsDetail,[lvoMultiSelect,lvoHeaderDragDrop
         ,lvoEditLabel],LocalViewimages,nil,nil).SetAlign(caLeft);
  with LocalListView^ do
  begin
{    ExStyle:=ExStyle+WS_EX_ACCEPTFILES;}//Not implemented yet!
    LVColAdd('Filename',taLeft,180);
    LvColAdd('FileSize',taRight,100);
    LvColAdd('Filetype',taLeft,100);
    width:=385;
    OnMessage:=Events.DoOnLocalListViewMessage;
    OnKeyUp:=events.onlistKeyup;
  end;

  Newsplitter(MainForm,0,0);
  RemoteViewImages:=NewImagelist(Mainform);
  RemotelistView:=NewListView(MainForm,lvsDetail,[lvoMultiSelect,lvoHeaderDragDrop
         ,lvoEditLabel],RemoteViewimages,nil,nil).SetAlign(caClient);

  with RemoteListView^ do
  begin
    ExStyle:=ExStyle+WS_EX_ACCEPTFILES;
    LVColAdd('Filename',taLeft,180);
    LvColAdd('FileSize',taRight,100);
    LvColAdd('Filetype',taLeft,100);
    OnMessage:=Events.DoOnRemoteListViewMessage;
    OnKeyUp:=events.onlistKeyup;
    end;

  Rpopup:=NewMenu(RemoteListView,0,['&DownLoad','-','&Delete','&Rename','New &Folder',''],events.dopopup);
  for i:=0 to Rpopup.Count-1 do
    RPopup.ItemEnabled[i]:=False;
  Lpopup:=NewMenu(LocalListView,0,['&UpLoad','-','&Delete','&Rename','New &Folder',''],events.dopopup);
    LPopup.ItemEnabled[0]:=False;

  Status:=NewEditBox(MainForm,[eoMultiLine]).SetAlign(caBottom);
  Status.Height:=1;//Hide it for now.

  Splitter:=NewSplitter(Mainform,0,0);

  MainMenu:=NewMenu(MainForm,0,['&FTP','(','&Site Manager','-','+!&Connect','-!&Disconnect','-','&Upload','&Download','-','E&xit',')',''],Events.DoMenu);
  MainMenu.ItemEnabled[Ord(mnDisConnect)]:=False;

  SitesForm:=NewForm(Applet,'Choose, Add or Remove a Site:').SetSize(500,300).CenterOnParent;
  SitesForm.CanResize:=false;
  SitesForm.Style:=Sitesform.style and not (WS_MAXIMIZEBOX OR WS_MINIMIZEBOX);
  SitesListBox:=NewListBox(SitesForm,[]).SetSize(150,220);
  SitesListBox.OnClick:=Events.SitesListBoxClick;
  SitesListBox.Top:=20;
  SitesListBox.Left:=20;
  Panel1:=NewPanel(SitesForm,esRaised).SetAlign(caBottom);
  CmdAdd:=NewButton(Panel1,'&Add').Resizeparent;

  Panel1.Canresize:=False;

  CmdAdd.SetAlign(caLeft);
  CmdAdd.OnClick:=Events.DoCmdAdd;

  CmdDelete:=NewButton(Panel1,'&Delete').SetAlign(caLeft);
  CmdDelete.OnClick:=Events.DoCmdDelete;

  CmdCancel:=NewButton(Panel1,'&Cancel').SetAlign(caRight);
  CmdCancel.OnClick:=Events.DoCmdCancel;

  CmdOk:=NewButton(Panel1,'&Ok').setalign(caRight);
  CmdOk.OnClick:=Events.DocmdOk;

  Label1:=NewLabel(SitesForm,'Site:');
  with Label1^ do
  begin
    Top:=20;
    left:=176;
    Width:=40;
  end;

  SiteName:=NewEditBox(SitesForm,[]);
  with SiteName^ do
  begin
    Left:=220;
    Top:=20;
    Width:=252;
  end;

  Label2:=NewLabel(Sitesform,'Host Address:');
  with Label2^ do
  begin
    top:=54;
    Left:=176;
    Width:=100;
  end;

  HostAddressName:=NewEditBox(SitesForm,[]);
  with HostAddressName^ do
  begin
    Top:=54;
    Left:=279;
    Width:=193;
  end;

  Label3:=NewLabel(SitesForm,'User Name:');
  with Label3^ do
  begin
    Top:=89;
    Left:=176;
    Width:=100;
  end;

  EdiUserName:=NewEditBox(SitesForm,[]);
  with EdiUserName^ do
  begin
    Left:=279;
    top:=89;
    Width:=193;
  end;

  Label4:=NewLabel(SitesForm,'Password:');
  with Label4^ do
  begin
    Left:=176;
    Top:=123;
    Width:=100;
  end;

  EdiPassword:=NewEditBox(SitesForm,[eoPassword]);
  with EdiPassword^ do
  begin
    Left:=279;
    Top:=123;
    Width:=193;
  end;

  cbAnonymous:=NewCheckBox(SitesForm,'Anonymous');
  with cbAnonymous^ do
  begin
    left:=279;
    Top:=158;
    width:=100;
  end;

  Label5:=NewLabel(SitesForm,'Port Number:');
  with Label5^ do
  begin
    Left:=176;
    Top:=195;
    Width:=100;
  end;

  EdiPort:=NewEditBox(SitesForm,[]);
  with Ediport^ do
  begin
    Left:=279;
    Top:=195;
    Width:=75;
  end;
  DragList:=NewList;
  Fsites:=NewStrList;
  LoadSites;
  LocalUpdateListing;
  Dircombobox.Focused:=true;
  Run(Applet);
  Fsites.Free;
  Events.free;
  tbImages.free;
  Draglist.release;
end.

